<?php

namespace Edispatcher\plugins\rocketchat;
use \Psr\Http\Message\ServerRequestInterface as Request;
use \Psr\Http\Message\ResponseInterface as Response;
use Slim\Container;
use Edispatcher\Controllers\BaseController;

use Edispatcher\plugins\rocketchat\client\Client;
use Edispatcher\plugins\rocketchat\client\User;

function randomToken($len = 64, $output = 5, $standardChars = true, $specialChars = true, $chars = array()) {
        $out = '';
        $len = intval($len);
        $outputMap = array(1 => 2, 2 => 8, 3 => 10, 4=> 16, 5 => 10);
        if (!is_array($chars)) { $chars = array_unique(str_split($chars)); }
        if ($standardChars) { $chars = array_merge($chars, range(48, 57),range(65, 90), range(97, 122)); }
        if ($specialChars) { $chars = array_merge($chars, range(33, 47),range(58, 64), range(91, 96), range(123, 126)); }
        array_walk($chars, function(&$val) { if (!is_int($val)) { $val = ord($val); } });
        if (is_int($len)) {
            while ($len) {
                $tmp = ord(openssl_random_pseudo_bytes(1));
                if (in_array($tmp, $chars)) {
                    if (!$output || !in_array($output, range(1,5)) || $output == 3 || $output == 5) { $out .= ($output == 3) ? $tmp : chr($tmp);  }
                    else {
                        $based = base_convert($tmp, 10, $outputMap[$output]);
                        $out .= ((($output == 1) ? '00' : (($output == 4) ? '0x' : '')) . (($output == 2) ? sprintf('%03d', $based) : $based));
                    }
                    $len--;
                }
            }
        }
        return (empty($out)) ? false : $out;
    }

class Controller extends BaseController {

      protected $ci;

      //Constructor
      public function __construct(Container $ci) {
        $this->ci = $ci;
      }

      private function getUserInfos() {
        global $__PLUGINS;
        if (!isset($__PLUGINS['rocketchat']))              {die("NOT CONFIGURED");}
        if (!isset($__PLUGINS['rocketchat']["url"]))       {die("URL CHAT NON DEFINIE");}
        if (!isset($__PLUGINS['rocketchat']["username"]))  {die("ADMIN username NON DEFINI");}
        if (!isset($__PLUGINS['rocketchat']["password"]))  {die("ADMIN password NON DEFINI");}

        define('REST_API_ROOT', '/api/v1/');
        define('ROCKET_CHAT_INSTANCE', $__PLUGINS['rocketchat']["url"]);

        $profil = $this->getProfil();
        if (!$profil->isPersAcad()) {
            die("NO PERS ACAD");
        }

        $api = new Client();
        $admin = new User($__PLUGINS['rocketchat']["username"], $__PLUGINS['rocketchat']["password"] );
        if( ! $admin->login() ) {
          die("Oups");
        };

        $user = $admin->findUser($profil->getUser());

        // Si user n'existe pas on va le créer
        if (!$user) {
          $admin->createUser($profil->getUser(),$profil->getDisplayName(),$profil->getMail());
          $user = $admin->findUser($profil->getUser());
        }
        
        $bCrypt = $user->services->password->bcrypt;
        $auth = \R::findOne("rocketchatoken","user = ? and bcrypt = ?",[$profil->getUser(),$bCrypt]);
        if (!$auth) {
            $password = randomToken(128, false, true, false);
            $user = $admin->createTokenForUsername($profil->getUser(),$password);
            $auth = \R::dispense("rocketchatoken");
            $auth->user      = $profil->getUser();
            $auth->password  = $password;
            $auth->bcrypt    = $user->services->password->bcrypt;
            $auth->accessAt  = new \DateTime("now");
            \R::store($auth);
        } else {
            $auth->accessAt = new \DateTime("now");
            $password       = $auth->password;
            \R::store($auth);
        }
        

        return $admin->authUser($profil->getUser(),$password);
      }

      public function loginAction(Request $request, Response $response, $args) {

          $params = [];

          $infos  = $this->getUserInfos();
          $params["data"] = $infos["data"];

          // Récupère de l'admin 
          global $__PLUGINS;
          $api = new Client();
          $admin = new User($__PLUGINS['rocketchat']["username"], $__PLUGINS['rocketchat']["password"] );
          if( ! $admin->login() ) {
            die("Oups");
          };

          $user   = $infos["user"];
          $profil = $this->getProfil();

          if ($profil->getUser()=="cleon") 
          {
            // List des channels 
            $rooms = explode(",",$profil->getAttribute("channels",''));

            // Tous les channels existants 
            $allChannels=$admin->listAll();

            //print_r($allChannels);
            
            foreach($rooms as $room ) {

                echo $admin->id;
                $admin->groupInviteUser("bFbsxweC5xD9zJjS6",$user->id);
                $infos = $user->get("groups.members?roomId=bFbsxweC5xD9zJjS6");
                if (!$infos) {
                  echo ":(";
                }
                print_r($infos);
                die();
            }

              die();

          }

          return $this->ci["view"]->render($response, '@rocketchat/login.html.twig',$params);
      }

      public function summaryAction(Request $request, Response $response, $args) {

          $profil = $this->getProfil();
          $uid    = $profil->getUser();
          if ($uid!="cleon" && $uid!="cjactard" && $uid!="arault" && $uid!="lbrillard" ) {
            die("");
          }

          $params = [];

          $infos  = $this->getUserInfos();
          $user   = $infos["user"];

          $subscriptions = $user->subscriptions();

          $unread=["p"  => [],
                   "d"  => [],
                   "c"  => []
                 ];

          foreach ($subscriptions as $subscription) {
            if ($subscription->_room->archived==1) {
              continue;
            }
            $name = $subscription->name;
            $messages = $user->getLastMessagesInRoom($subscription->rid,$subscription->t,$subscription->ls);
            $messages = array_filter($messages, function($m) use($user){return $m->u->_id != $user->id;});

            if (count($messages)!=0) {
              $unread[$subscription->t][$name] = [count($messages),$subscription->unread] ;
            }

          }

          $array = [ ["d" => $unread["d"]], ["p" => $unread["p"]] , ["c" => $unread["c"]]  ];

          $message = "";
          $count = 0; $private=0; $total = 0;
          foreach ($array as $values) {
            reset($values);
            $t = key($values);
            foreach ($values[$t] as $key=>$value) {
              $message.= $this->formatUnread($key,$value,$t);
              $total++;
              $count+=$value[0];
              $private+=$value[1];
              if ($total > 3 ) {
                break;
              }
            }
            if ($total > 3 ) {
              $message .= " ...";
              break;
            }
          }

          /*foreach ($unread["p"] as $key=>$value) {
            $message.= $this->formatUnread($key,$value,"p");
            $count+=$value[0];$private+=$value[1];
          }
          foreach ($unread["p"] as $key=>$value) {
            $message.= $this->formatUnread($key,$value,"p");
            $count+=$value[0];$private+=$value[1];
          }*/

          if ($message=="") {
            die("");
          }

          $header = "Vous avez <span class=\"badge\">".$count."</span> message" . ($count>1?"s":"");
          if ($private!=0) {
            $header .= " dont <span class=\"badge\">".$private."</span> vous cite" . ($private>1?"nt":"") . ".";
          }
          $header .= " , voici le détail :<br>";

          $this->sendResponse($count,$header.$message);



      }

      public function formatUnread($key,$counts,$t) {
        $m = "";
          $prefix = ""; $suffix= " ⇢";
          if ($t=="d") {$prefix="<span style=\"color:black\">💬</span> @";}
          if ($t=="p") {$prefix="🔒 <b>";$suffix="</b> ⇢";}
          if ($t=="c") {$prefix="# <b>";$suffix="</b> ⇢";}

          $m .=  $prefix . $key . $suffix . " <span class=\"badge\">".$counts[0]."</span>" ;
          if ($counts[0]!=$counts[1] && $counts[1] != 0 && $t != "d" ) {
            $m .= " (dont ". $counts[1]  . " 💬 " .")";
          }
          if ($counts[0]==$counts[1] && $counts[1] != 0) {
            $m .= "";
          }

        return $m. "<br>";
      }

      public function sendResponse($count,$message) {

          $json=json_encode(array("message"=>$message,"count"=>$count));
          if (isset($_GET["api"])) {
              $id=$_GET["id"];
              $api=$_GET["api"];
              header('Content-Type: text/javascript');
              echo "var data=$json;";
              echo "$api('$id',data);";
              die();
          }

          echo "<html><body>";
          echo "<form id='form2submit' name='form2submit' method='POST' action='".$_GET["callback"]."'>";
          echo "<input name='id' id='id' type='hidden' value='".$_GET["id"]."' />";
          echo "<input name='count' id='count' type='hidden' value='".$count."' />";
          echo "<input name='type' id='type' type='hidden' value='"."count"."' />";
          echo "<input name='message' id='message' type='hidden' value='$message' />";
          echo "</form>";
          echo "<script>";
          echo "document.form2submit.submit();";
          echo "</script>";
          echo "</body></html>";
      }


      public function apiAction(Request $request, Response $response, $args) {

          $params = [];
          header("Access-Control-Allow-Credentials: true");
          header("Access-Control-Allow-Methods: POST, GET, JSON");
          header("Access-Control-Allow-Origin: https://chat.ac-reunion.fr");
          die("");
          return $this->ci["view"]->render($response, '@rocketchat/login.html.twig',$params);
      }

}
